package com.laguerre.kan;

import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

public abstract class Mesh extends Component {
	public void init() {
	}

	public abstract int getNbOfSubMeshes();

	public abstract int getVertexCount(int subMeshId);
	public abstract int getVertexStride(int subMeshId);
	public abstract FloatBuffer getSharedVertexBuffer(int subMeshId);

	public abstract int getNormalStride(int subMeshId);
	public abstract FloatBuffer getSharedNormalBuffer(int subMeshId);

	public final int getUVStride(int subMeshId) {
		return getSharedTexCoordStride(subMeshId, 0);
	}

	public final FloatBuffer getSharedUVBuffer(int subMeshId) {
		return getSharedTexCoordBuffer(subMeshId, 0);
	}

	public abstract int getSharedTexCoordStride(int subMeshId, int textureId);
	public abstract FloatBuffer getSharedTexCoordBuffer(int subMeshId, int textureId);

	public abstract int getDrawListCount(int subMeshId);
	public abstract ShortBuffer getSharedDrawListBuffer(int subMeshId);
}
