package com.laguerre.mytest;

import com.laguerre.kan.Behaviour;
import com.laguerre.kan.ImageEffects;
import com.laguerre.kan.PassShader;
import com.laguerre.kan.Shader;
import com.laguerre.kan.SurfaceInfo;
import com.laguerre.kan.Utils;

public class GaussianBlurImageEffect extends Behaviour {
	private final Shader gaussianShader = new Shader();
	private final int[] screenDim = {0, 0};

	@Override
	public void onAwake() {
		final PassShader passGaussian = this.gaussianShader.addPassShader(0);
		passGaussian.createProgram();
		passGaussian.attachVertexShader(ImageEffects.getBasicVertexShaderCode());
		passGaussian.attachFragmentShader(Utils.readTextFileFromRawResource(
				Utils.getContext(), R.raw.gaussian_blur_f_glsl));
		passGaussian.linkProgram();

		ImageEffects.getInstance().useAlternativeShader(this.gaussianShader);
	}

	@Override
	public void onBeforeRenderingImageEffectsPass(int passNum) {
		SurfaceInfo.getInstance().getSurfaceSize(this.screenDim);
		final float[] texSteps = { 1.0f / this.screenDim[0], 1.0f / this.screenDim[1] };
		this.gaussianShader.setShaderVector("texSteps", texSteps);
	}

	@Override
	public void onDestroy() {
		gaussianShader.destroyResources();
	}
}
