package com.laguerre.mytest;

import com.laguerre.kan.Behaviour;
import com.laguerre.kan.ImageEffects;
import com.laguerre.kan.PassShader;
import com.laguerre.kan.Shader;
import com.laguerre.kan.SurfaceInfo;
import com.laguerre.kan.Utils;

public class LaplaceEdgeImageEffect extends Behaviour {
	private final Shader laplaceShader = new Shader();
	private final int[] screenDim = {0, 0};

	@Override
	public void onAwake() {
		final PassShader passLaplace = this.laplaceShader.addPassShader(0);
		passLaplace.createProgram();
		passLaplace.attachVertexShader(ImageEffects.getBasicVertexShaderCode());
		passLaplace.attachFragmentShader(Utils.readTextFileFromRawResource(
				Utils.getContext(), R.raw.laplace_edge_f_glsl));
		passLaplace.linkProgram();

		ImageEffects.getInstance().useAlternativeShader(this.laplaceShader);
	}

	@Override
	public void onBeforeRenderingImageEffectsPass(int passNum) {
		SurfaceInfo.getInstance().getSurfaceSize(this.screenDim);
		final float[] texSteps = { 1.0f / this.screenDim[0], 1.0f / this.screenDim[1] };
		this.laplaceShader.setShaderVector("texSteps", texSteps);
	}

	@Override
	public void onDestroy() {
		laplaceShader.destroyResources();
	}
}
